Imports System.Runtime.InteropServices
Imports Microsoft.Win32

Public Class ClockForm

    Private mousePoint As Point                 ' }EX|Cg
    Private bMove As Boolean = False            ' ʒuړsۂ
    Private movePoint As Point
    Private strWorldClockTimeZone As String     ' Tuṽ^C][
    Private opitonForm As OptionForm

    <DllImport("Gdi32.dll")> _
    Friend Shared Function GetDeviceCaps(ByVal hdc As IntPtr, ByVal nIndex As Integer) As Integer
    End Function

    <DllImport("User32.dll")> _
    Friend Shared Function GetDC(ByVal hWnd As IntPtr) As IntPtr
    End Function

    <DllImport("User32.dll")> _
    Friend Shared Function ReleaseDC(ByVal hWnd As IntPtr, ByVal hDC As IntPtr) As Integer
    End Function
    Public Const BITSPIXEL As Integer = 12


    Public Sub New()

        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()
        Me.SuspendLayout()
        Dim img As Bitmap = CType(Global.DigitalClock.My.Resources.Resources.body, Bitmap)
        img.MakeTransparent(Color.FromArgb(255, 100, 200))
        Me.BackgroundImage = img
        Me.ResumeLayout(False)
        ' InitializeComponent() Ăяǒŏǉ܂B
    End Sub

    ''' <summary>
    ''' Tuv̕\
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub OpenImageButtonCtl_Click() Handles OpenImageButton.Click
        Dim clockSize As Size = New Size(284, 142)
        Dim areaRect As Drawing.Rectangle = My.Computer.Screen.WorkingArea()

        If Me.Size.Height = clockSize.Height Then
            If Me.DesktopLocation.Y + Me.Size.Height * 2 > areaRect.Height Then
                movePoint = New Point(Me.DesktopLocation.X, Me.DesktopLocation.Y)
                Me.DesktopLocation = New Point(Me.DesktopLocation.X, areaRect.Height - clockSize.Height * 2)
                bMove = True
            End If
            Me.Size = New Size(clockSize.Width, clockSize.Height * 2)
            Me.WorldTimeZoneNameLable.Text = Me.WorldDigitalClock.CurrentTimeZone
        Else
            If bMove = True Then
                Me.DesktopLocation = New Point(movePoint.X, movePoint.Y)
                bMove = False
            End If
            Me.Size = New Size(clockSize.Width, clockSize.Height)
        End If
    End Sub

    ''' <summary>
    ''' IvV{^NbNꂽƂ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub OptionImageButtonCtl_Click() Handles OptionImageButton.Click
        OptionFormDisplay()
    End Sub

    ''' <summary>
    ''' IvV _CAO̕\
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub OptionFormDisplay()
        opitonForm = New OptionForm(Me)

        ' [IvV]_CAOɏp
        ' ^C ][
        opitonForm.TimeZoneComboBox.Items.AddRange(Me.WorldDigitalClock.TimeZoneNames.ToArray())
        If WorldDigitalClock.CurrentTimeZone = "" Then
            opitonForm.TimeZoneComboBox.SelectedItem = NowDigitalClock.OSTimeZoneName
        Else
            opitonForm.TimeZoneComboBox.SelectedItem = WorldDigitalClock.CurrentTimeZone
        End If

        ' x
        If GetDisplayColorBit() >= 24 Then
            opitonForm.OpacityTrackBar.Value = Me.Opacity * 10 - 1
        Else
            opitonForm.OpacityTrackBar.Value = 9
            opitonForm.OpacityTrackBar.Enabled = False
        End If

        ' tH[ɎԂɕ\邩ۂݒ
        opitonForm.topMostCheckBox.Checked = Me.TopMost
        ' gbv[Xg\ĂꍇA[IvV]_CAOgbv[Xgɐݒ肷
        If Me.TopMost = True Then
            opitonForm.TopMost = True
        End If


        ' Cv
        ' A[炷ۂ
        opitonForm.NowAlarmCheckBox.Checked = Me.NowSwitchImageButton.Switch
        ' A[炷
        opitonForm.txtNowAlarmTime.Text = Me.NowDigitalClock.AlarmTime.ToString("HH/mm")
        ' TEht@C
        opitonForm.txtNowAlarmSoundFile.Text = Me.NowDigitalClock.SoundFileName

        ' Tuv
        ' A[炷ۂ  
        opitonForm.WorldAlarmCheckBox.Checked = Me.WorldSwitchImageButton.Switch
        ' A[炷
        opitonForm.txtWorldAlarmTime.Text = Me.WorldDigitalClock.AlarmTime.ToString("HH/mm")
        ' TEht@C
        opitonForm.txtWorldAlarmSoundFile.Text = Me.WorldDigitalClock.SoundFileName


        ' [IvV]_CAOJ
        opitonForm.ShowDialog()

    End Sub

    ''' <summary>
    ''' ON/OFF 摜`悷郁\bh
    ''' </summary>
    ''' <param name="switchImage">True=On,False=Off</param>
    ''' <param name="imageCtl">ON/OFF؂ւ SwitchImageButtonCtl</param>
    ''' <remarks></remarks>
    Private Sub SetSwitchImageButton(ByVal switchImage As Boolean, ByVal imageCtl As Control)
        If switchImage = True Then
            ' On 摜`
            imageCtl.BackgroundImage = Global.DigitalClock.My.Resources.Resources.switchon
        Else
            ' Off 摜`
            imageCtl.BackgroundImage = Global.DigitalClock.My.Resources.Resources.switchoff
        End If
    End Sub

    ''' <summary>
    '''  AvP[VJƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ClockForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' config t@C̎擾
        ' AvP[V\ʒuƃTCYݒ()
        If My.Settings.DesktopLocation.X = -300 And My.Settings.DesktopLocation.Y = -300 Then
            Me.StartPosition = FormStartPosition.CenterParent
            Me.Size = My.Settings.ClockSize
        Else
            Me.SetDesktopBounds(My.Settings.DesktopLocation.X, My.Settings.DesktopLocation.Y, My.Settings.ClockSize.Width, My.Settings.ClockSize.Height)
        End If

        ' Tuṽ^C ][ݒ
        strWorldClockTimeZone = My.Settings.WorldTimeZone
        Me.WorldDigitalClock.CurrentTimeZone = strWorldClockTimeZone
        ' ^C][\
        Me.WorldTimeZoneNameLable.Text = strWorldClockTimeZone                      ' Tuv
        Me.NowTimeZoneNameLable.Text = Me.NowDigitalClock.OSTimeZoneName.ToString   ' Cv
        ' x̐ݒ
        If GetDisplayColorBit() >= 24 Then      ' ʂ̐F24rbgȏ̏ꍇ
            Me.Opacity = My.Settings.AppOpacity
        Else                                    ' ʂ̐F24rbg̏ꍇ
            Me.Opacity = 100
        End If

        ' tH[ɎԂɕ\邩ۂݒ
        Me.TopMost = My.Settings.FormTopMost


        ' Cv
        ' ON/OFF 摜̐ݒ
        Me.NowSwitchImageButton.Switch = My.Settings.NowAlarm
        SetSwitchImageButton(My.Settings.NowAlarm, Me.NowSwitchImageButton)
        ' ݒ
        Me.NowDigitalClock.AlarmTime = TimeValue(My.Settings.NowAlarmTime)
        ' 炷TEht@Cݒ
        Me.NowDigitalClock.SoundFileName = My.Settings.NowSoundFileName
        ' A[p̃^C}[Jn
        If My.Settings.NowAlarm = True Then
            Me.NowDigitalClock.AlarmClockTimer.Start()
        End If

        ' Tuv
        ' ON/OFF 摜̐ݒ
        Me.WorldSwitchImageButton.Switch = My.Settings.WorldAlarm
        SetSwitchImageButton(My.Settings.WorldAlarm, Me.WorldSwitchImageButton)
        ' ݒ
        Me.WorldDigitalClock.AlarmTime = TimeValue(My.Settings.WorldAlarmTime)
        ' 炷TEht@Cݒ
        Me.WorldDigitalClock.SoundFileName = My.Settings.WorldSoundFileName
        ' A[p̃^C}[Jn
        If My.Settings.WorldAlarm = True Then
            Me.WorldDigitalClock.AlarmClockTimer.Start()
        End If

        ' DisplaySettingsChanged Cxgnh̐ݒ
        AddHandler SystemEvents.DisplaySettingsChanged, AddressOf SystemEvents_DisplaySettingsChanged

    End Sub

    ''' <summary>
    ''' fBXṽJ[rbg擾
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function GetDisplayColorBit() As Integer
        'XN[foCXReLXg擾
        Dim hDC As IntPtr = GetDC(IntPtr.Zero)
        'J[rbg擾
        Dim iRes As Integer = GetDeviceCaps(hDC, BITSPIXEL)
        'XN[foCXReLXg
        ReleaseDC(IntPtr.Zero, hDC)
        Return iRes
    End Function 'GetDisplayColorBit

    ''' <summary>
    ''' {^NbNꂽƂ
    ''' </summary>
    ''' <remarks>config t@CɏۑA</remarks>
    Private Sub CloseImageButtonCtl_Click() Handles CloseImageButtonCtl.Click
        SaveConfigFile()
        ' AvP[V
        Me.Close()
    End Sub

    ''' <summary>
    ''' config t@Cɏۑ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SaveConfigFile()
        ' AvP[V̈ʒu
        My.Settings.DesktopLocation = New Point(Me.DesktopLocation.X, Me.DesktopLocation.Y)
        ' AvP[VTCY
        My.Settings.ClockSize = Me.Size
        My.Settings.AppOpacity = Me.Opacity                 ' x
        My.Settings.FormTopMost = Me.TopMost                ' tH[ɎԂɕ\邩ۂݒ

        ' Cv
        My.Settings.NowAlarm = Me.NowSwitchImageButton.Switch
        My.Settings.NowSoundFileName = Me.NowDigitalClock.SoundFileName
        My.Settings.NowAlarmTime = Me.NowDigitalClock.AlarmTime.ToString
        'Tuv
        My.Settings.WorldTimeZone = Me.WorldDigitalClock.CurrentTimeZone   ' ^C ][
        My.Settings.WorldAlarm = Me.WorldSwitchImageButton.Switch
        My.Settings.WorldSoundFileName = Me.WorldDigitalClock.SoundFileName
        My.Settings.WorldAlarmTime = Me.WorldDigitalClock.AlarmTime.ToString

    End Sub

    ''' <summary>
    ''' ^XNgC[IvV]j[IꂽƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub OpitonToolStrip_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpitonToolStrip.Click
        OptionFormDisplay()
    End Sub

    ''' <summary>
    ''' ^XNgĆuvj[IꂽƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CloseToolStrip_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CloseToolStrip.Click
        SaveConfigFile()
        Me.Close()
    End Sub

    ''' <summary>
    ''' tH[̈ړ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub DigitalClock_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NowDigitalClock.MouseDown, WorldDigitalClock.MouseDown, NowTimeZoneNameLable.MouseDown, WorldTimeZoneNameLable.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            mousePoint = New Point(e.X, e.Y)
        End If
    End Sub

    Private Sub DigitalClock_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NowDigitalClock.MouseMove, WorldDigitalClock.MouseMove, NowTimeZoneNameLable.MouseMove, WorldTimeZoneNameLable.MouseMove
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ' tH[̈ʒufXNgbvWŐݒ
            Me.SetDesktopLocation(Me.Left - mousePoint.X + e.X, Me.Top - mousePoint.Y + e.Y)
        End If
    End Sub

    ''' <summary>
    ''' ^XNgC̃ACRNbNƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>fW^vANeBuɂ</remarks>
    Private Sub NotifyIcon1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then
            Me.Activate()
        End If

    End Sub

    ''' <summary>
    ''' CṽA[ݒ肪ύXꂽƂ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub NowSwitchImageButton_ChangeSwitch() Handles NowSwitchImageButton.ChangeSwitch
        Me.NowDigitalClock.AlarmSetting = Me.NowSwitchImageButton.Switch    ' A[ݒ肷邩ۂݒ

        If NowDigitalClock.AlarmSetting = True Then
            Me.NowDigitalClock.AlarmClockTimer.Start()                      ' A[p̃^C}[Jn
        Else
            If Me.NowDigitalClock.AlarmClockTimer.Enabled = True Then
                Me.NowDigitalClock.AlarmClockTimer.Stop()                   ' A[p̃^C}[~߂
            End If
        End If
    End Sub

    ''' <summary>
    ''' TuṽA[ݒ肪ύXꂽƂ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub WorldSwitchImageButton_ChangeSwitch() Handles WorldSwitchImageButton.ChangeSwitch
        Me.WorldDigitalClock.AlarmSetting = Me.WorldSwitchImageButton.Switch      ' A[ݒ肷邩ۂݒ

        If WorldDigitalClock.AlarmSetting = True Then
            Me.WorldDigitalClock.AlarmClockTimer.Start()                        ' A[p̃^C}[Jn
        Else
            If Me.WorldDigitalClock.AlarmClockTimer.Enabled = True Then
                Me.WorldDigitalClock.AlarmClockTimer.Stop()                     ' A[p̃^C}[~߂
            End If
        End If
    End Sub

    ''' <summary>
    ''' \ݒiʂ̐F̃rbgjύXꂽƂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub SystemEvents_DisplaySettingsChanged(ByVal sender As Object, ByVal e As EventArgs)
        Me.Opacity = My.Settings.AppOpacity
        opitonForm.OpacityTrackBar.Value = 9
        If GetDisplayColorBit() >= 24 Then              ' ʂ̐F 24 rbgȏ̏ꍇ
            opitonForm.OpacityTrackBar.Enabled = True
        Else                                            ' ʂ̐F 24 rbg̏ꍇ
            opitonForm.OpacityTrackBar.Enabled = False
        End If
    End Sub
End Class