Public Class OptionForm

    Private clockForm As ClockForm

    Public Sub New(ByVal fr As ClockForm)
        MyBase.New()
        clockForm = fr
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' [OK]{^A [Kp]{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OKButton.Click, ApplyButton.Click

        If IsDate(Me.txtNowAlarmTime.Text) = False Then
            If Me.NowAlarmCheckBox.Checked = True Then
                MessageBox.Show("A[𐳂ݒ肵ĂB", "Cv")
                Exit Sub
            ElseIf Me.NowAlarmCheckBox.Checked = False Then
                Me.txtNowAlarmTime.Text = clockForm.NowDigitalClock.AlarmTime.ToString("HH/mm")
            End If
        End If

        If IsDate(Me.txtWorldAlarmTime.Text) = False Then
            If Me.WorldAlarmCheckBox.Checked = True Then
                MessageBox.Show("A[𐳂ݒ肵ĂB", "Tuv")
                Exit Sub
            ElseIf Me.WorldAlarmCheckBox.Checked = False Then
                Me.txtWorldAlarmTime.Text = clockForm.WorldDigitalClock.AlarmTime.ToString("HH/mm")
            End If
        End If

        Dim dataClass As New OptionDataSetClass(clockForm, Me)
        dataClass.setOption()

        Me.txtNowAlarmTime.Text = clockForm.NowDigitalClock.AlarmTime.ToString("HH/mm")
        Me.txtWorldAlarmTime.Text = clockForm.WorldDigitalClock.AlarmTime.ToString("HH/mm")

        If CType(sender, Button).Text = "OK" Then
            Me.Close()
        End If

    End Sub

    ''' <summary>
    ''' TEht@Cw肷
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub FileButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NowOpenSoundFileButton.Click, WorldOpenSoundFileButton.Click

        OpenFileDialog1.Title = "A[̃TEht@Cw"
        OpenFileDialog1.FileName = ""
        OpenFileDialog1.Filter = "TEh t@C(*.wav)|*.wav"

        If OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim stFileName As String = OpenFileDialog1.FileName
            Select Case CType(sender, Button).Name.ToString()
                ' Cv
                Case "NowOpenSoundFileButton"
                    Me.txtNowAlarmSoundFile.Text = stFileName       ' t@C̃tpX TextBox ɕ\
                    ' Tuv
                Case "WorldOpenSoundFileButton"
                    Me.txtWorldAlarmSoundFile.Text = stFileName     ' t@C̃tpX TextBox ɕ\
            End Select

        End If
        OpenFileDialog1.Dispose()
    End Sub

    ''' <summary>
    ''' Cṽ^C}[ݒ肵ȂꍇAETEht@C̐ݒ𖳌ɂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub NowAlarmCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NowAlarmCheckBox.CheckedChanged
        Dim alarmCheck As Boolean = Me.NowAlarmCheckBox.Checked
        Me.txtNowAlarmTime.Enabled = alarmCheck
        Me.txtNowAlarmSoundFile.Enabled = alarmCheck
        Me.NowOpenSoundFileButton.Enabled = alarmCheck
    End Sub

    ''' <summary>
    ''' Tuṽ^C}[ݒ肵ȂꍇAETEht@C̐ݒ𖳌ɂ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub WorldAlarmCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WorldAlarmCheckBox.CheckedChanged
        Dim alarmCheck As Boolean = Me.WorldAlarmCheckBox.Checked
        Me.txtWorldAlarmTime.Enabled = alarmCheck
        Me.txtWorldAlarmSoundFile.Enabled = alarmCheck
        Me.WorldOpenSoundFileButton.Enabled = alarmCheck
    End Sub

    
End Class