Imports System.ComponentModel

Public Class TimeZoneNameLableCtl

    Private _textAlign As ContentAlignment = ContentAlignment.TopLeft   ' eLXgʒu
    Private _textMainColor As Color = Color.YellowGreen                 ' C̐F
    Private _textShadowColor As Color = Color.Black                     ' e̐F

    ''' <summary>
    ''' eLXgiCj\R|[lg̐F
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property TextMainColor() As Color
        Get
            Return _textMainColor
        End Get
        Set(ByVal value As Color)
            _textMainColor = value
            Me.Refresh()
        End Set
    End Property

    ''' <summary>
    ''' eLXgiej\R|[lg̐F
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property TextShadowColor() As Color
        Get
            Return _textShadowColor
        End Get
        Set(ByVal value As Color)
            _textShadowColor = value
            Me.Refresh()
        End Set
    End Property

    ''' <summary>
    ''' eLXg̔zu
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property TextAlign() As ContentAlignment
        Get
            Return _textAlign
        End Get
        Set(ByVal value As ContentAlignment)
            _textAlign = value
            Me.Refresh()
        End Set
    End Property

    ''' <summary>
    ''' Font vpeB
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Browsable(True), _
     DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)> _
    Public Overrides Property Font() As Font
        Get
            Return MyBase.Font
        End Get
        Set(ByVal value As Font)
            MyBase.Font = value
            Me.Invalidate()
        End Set
    End Property

    ''' <summary>
    ''' Text vpeB
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Browsable(True), _
 DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)> _
    Public Overrides Property Text() As String
        Get
            Return MyBase.Text
        End Get
        Set(ByVal value As String)
            MyBase.Text = value
            Me.Invalidate()
        End Set
    End Property

    Public Sub New()

        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒŏǉ܂B

    End Sub

    Private Sub TimeZoneNameLableCtl_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        DrawTimeZoneName(e.Graphics, Me.Text, Me.Font, TextMainColor, TextShadowColor, TextAlign)
    End Sub

    ''' <summary>
    ''' et`悷
    ''' </summary>
    ''' <param name="g">Graphics NX</param>
    ''' <param name="strText">`悷镶</param>
    ''' <param name="oFont">tHg</param>
    ''' <param name="mainColor">iCj\R|[lg̐F</param>
    ''' <param name="shadowColor">iej\R|[lg̐F</param>
    ''' <param name="ca">̕\ʒu</param>
    ''' <remarks></remarks>
    Public Sub DrawTimeZoneName(ByVal g As Graphics, ByVal strText As String, ByVal oFont As Font, ByVal mainColor As Color, ByVal shadowColor As Color, ByVal ca As ContentAlignment)
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
        g.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        ' eLXg\R|[lg̐F
        Dim mainBrush As New SolidBrush(Color.FromArgb(180, mainColor.R, mainColor.G, mainColor.B))      ' C
        Dim shadowBrush As New SolidBrush(Color.FromArgb(180, shadowColor.R, shadowColor.G, shadowColor.B)) ' e

        ' eLXg̔zuw
        Dim stringFormat As StringFormat = GetStringFormat(ca)
        ' w肵eLXg̕`

        g.DrawString(strText, oFont, shadowBrush, New Rectangle(1, 1, Me.ClientRectangle.Width, Me.ClientRectangle.Height), stringFormat)  ' e
        g.DrawString(strText, oFont, mainBrush, Me.ClientRectangle, stringFormat)    ' C
        '  
        g.Dispose()
    End Sub

    ''' <summary>
    ''' ̕\ʒuݒ
    ''' </summary>
    ''' <param name="ca"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetStringFormat(ByVal ca As ContentAlignment) As StringFormat
        Dim stringFormat As New StringFormat()
        stringFormat.FormatFlags = StringFormatFlags.NoWrap

        Select Case ca
            Case ContentAlignment.BottomCenter      ' [
                stringFormat.Alignment = StringAlignment.Center
                stringFormat.LineAlignment = StringAlignment.Far
            Case ContentAlignment.BottomLeft        ' [
                stringFormat.Alignment = StringAlignment.Near
                stringFormat.LineAlignment = StringAlignment.Far
            Case ContentAlignment.BottomRight       ' [E
                stringFormat.Alignment = StringAlignment.Far
                stringFormat.LineAlignment = StringAlignment.Far
            Case ContentAlignment.MiddleCenter      ' i
                stringFormat.Alignment = StringAlignment.Center
                stringFormat.LineAlignment = StringAlignment.Center
            Case ContentAlignment.MiddleLeft        ' i
                stringFormat.Alignment = StringAlignment.Near
                stringFormat.LineAlignment = StringAlignment.Center
            Case ContentAlignment.MiddleRight       ' i
                stringFormat.Alignment = StringAlignment.Far
                stringFormat.LineAlignment = StringAlignment.Center
            Case ContentAlignment.TopCenter         ' [
                stringFormat.Alignment = StringAlignment.Center
                stringFormat.LineAlignment = StringAlignment.Near
            Case ContentAlignment.TopLeft           ' [
                stringFormat.Alignment = StringAlignment.Near
                stringFormat.LineAlignment = StringAlignment.Near
            Case ContentAlignment.TopRight          ' [E
                stringFormat.Alignment = StringAlignment.Far
                stringFormat.LineAlignment = StringAlignment.Near
        End Select

        Return stringFormat
    End Function 'GetStringFormat

End Class
