Imports system.Drawing.Drawing2D

Public Class DigitalClockCtl

    Private m_strCurrentTimeZone As String = ""
    Private m_tz As TimeZone

    Public Sub New()

        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()
        ' InitializeComponent() Ăяǒŏǉ܂B
        m_tz = New TimeZone()

    End Sub

    ' Rg[Ɏw肳ꂽ݂̃^C][
    Public Property CurrentTimeZone() As String
        Get
            Return m_strCurrentTimeZone
        End Get
        Set(ByVal value As String)
            m_strCurrentTimeZone = value
        End Set
    End Property

    ' ݂Ă^C][SĎ擾
    Public ReadOnly Property TimeZoneNames() As ArrayList
        Get
            Return m_tz.TimeZoneNames
        End Get
    End Property

    ' OS ̃^C][擾
    Public ReadOnly Property OSTimeZoneName() As String
        Get
            Return m_tz.GetOsTimeZoneName()
        End Get
    End Property

    Private Sub ClockTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClockTimer.Tick
        DrawNowTime()
    End Sub

    ''' <summary>
    ''' tH[ĕ`悷Ƃ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub DigitalClockCtl_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        DrawNowTime()
    End Sub

    ''' <summary>
    ''' ̕\
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DrawNowTime()
        Dim g As Graphics = CreateGraphics()

        ' Ñf[^擾
        Dim strYear As String = m_tz.TzNowDateTime(Me.CurrentTimeZone).Year.ToString         ' N
        Dim strMoth As String = m_tz.TzNowDateTime(Me.CurrentTimeZone).Month.ToString        ' 
        If strMoth.Length = 1 Then
            strMoth = "0" + strMoth
        End If
        Dim strDay As String = m_tz.TzNowDateTime(Me.CurrentTimeZone).Day.ToString           ' 
        If strDay.Length = 1 Then
            strDay = "0" + strDay
        End If

        ' Ԃ̃f[^擾
        Dim strHour As String = m_tz.TzNowDateTime(Me.CurrentTimeZone).Hour.ToString         ' 
        If strHour.Length = 1 Then
            strHour = "0" + strHour
        End If
        Dim strMinute As String = m_tz.TzNowDateTime(Me.CurrentTimeZone).Minute.ToString     ' 
        If strMinute.Length = 1 Then
            strMinute = "0" + strMinute
        End If
        Dim strSecond As String = m_tz.TzNowDateTime(Me.CurrentTimeZone).Second.ToString     ' b
        If strSecond.Length = 1 Then
            strSecond = "0" + strSecond
        End If


        ' C[W
        Dim smallNumbersImg As Image = CType(Global.DigitalClock.My.Resources.Resources.small, Image)       ' N\C[W
        Dim middleNumbersImg As Image = CType(Global.DigitalClock.My.Resources.Resources.middle, Image)     ' b\C[W
        Dim bigNumbersImg As Image = CType(Global.DigitalClock.My.Resources.Resources.big, Image)           ' \C[W

        ' C[W̕`
        ' t
        DrawImageFont(g, strYear, smallNumbersImg, New Point(180, 58), 7)       ' N
        DrawImageFont(g, strMoth, smallNumbersImg, New Point(180, 73), 7)       ' 
        DrawImageFont(g, strDay, smallNumbersImg, New Point(198, 73), 7)        ' 
        ' 
        DrawImageFont(g, strHour, bigNumbersImg, New Point(28, 60), 35)         ' 
        DrawImageFont(g, strMinute, bigNumbersImg, New Point(108, 60), 35)      ' 
        DrawImageFont(g, strSecond, middleNumbersImg, New Point(180, 93), 13)   ' b


        g.Dispose()
    End Sub

    ''' <summary>
    '''  fW^C[W̕`
    ''' </summary>
    ''' <param name="g">Graphics</param>
    ''' <param name="strLine">f[^</param>
    ''' <param name="imgNumbers">C[Wt@C</param>
    ''' <param name="point">ŏɕ`悷C[W̕\W</param>
    ''' <param name="n">X W̑</param>
    ''' <remarks></remarks>
    Private Sub DrawImageFont(ByVal g As Graphics, ByVal strLine As String, ByVal imgNumbers As Image, ByVal point As Point, ByVal n As Integer)
        Dim i As Integer
        For i = 0 To strLine.Length - 1
            Dim iLine As Integer = CType(strLine.Substring(i, 1), Integer)
            Dim iLineWidth As Integer = imgNumbers.Size.Width / 10
            Dim destRect As Rectangle = New Rectangle(point.X + n * i, point.Y, iLineWidth, imgNumbers.Size.Height)

            Dim secRect As Rectangle = New Rectangle(iLineWidth * iLine, 0, iLineWidth, imgNumbers.Size.Height)
            g.DrawImage(imgNumbers, destRect, secRect, GraphicsUnit.Pixel)
        Next
    End Sub

    Private m_AlarmTime As DateTime ' A[
    Private m_strSoundFileName As String = ""   ' TEht@C

    ''' <summary>
    ''' A[
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property AlarmTime() As DateTime
        Get
            Return m_AlarmTime
        End Get
        Set(ByVal value As DateTime)
            m_AlarmTime = value
        End Set
    End Property

    ''' <summary>
    ''' TEht@C
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property SoundFileName() As String
        Get
            Return m_strSoundFileName
        End Get
        Set(ByVal value As String)
            m_strSoundFileName = value
        End Set
    End Property

    ''' <summary>
    ''' AlarmClockTimer ̏
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property AlarmSetting() As Boolean
        Get
            Return Me.AlarmClockTimer.Enabled
        End Get
        Set(ByVal value As Boolean)
            Me.AlarmClockTimer.Enabled = value
        End Set
    End Property

    Private Sub AlarmTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AlarmClockTimer.Tick
        ' ݂̎A[ɂȂꍇ
        If m_tz.TzNowDateTime(Me.CurrentTimeZone).ToString("HH/mm/ss") = AlarmTime.ToString("HH/mm") & "/00" Then
            ' TEh炷
            Try
                My.Computer.Audio.Play(SoundFileName)

            Catch ex As Exception
                Dim timeZone As String = Me.CurrentTimeZone
                If timeZone = "" Then
                    timeZone = Me.OSTimeZoneName
                End If
                MessageBox.Show(AlarmTime.ToString("HH:mm") & " ɂȂ܂B", timeZone)
            End Try
        End If
    End Sub

    Private Sub DigitalClockCtl_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim img As Bitmap = CType(Me.BackgroundImage, Bitmap)
        If img IsNot Nothing Then
            img.MakeTransparent(Color.FromArgb(255, 100, 200))
            Me.BackgroundImage = img
        End If
    End Sub
End Class

