''' <summary>
''' [IvV]_CAO̐ݒe ClockForm ɑΉNX
''' </summary>
''' <remarks></remarks>
Public Class OptionDataSetClass

    Private clockForm As ClockForm      ' fW^v
    Private optionForm As OptionForm    ' IvV

    Public Sub New(ByVal fr As ClockForm, ByVal optionfr As OptionForm)
        MyBase.New()
        clockForm = fr
        optionForm = optionfr
    End Sub

    ''' <summary>
    ''' [IvV]_CAO̐ݒe ClockForm ɑΉ
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub setOption()
        ' ߓx
        SetOpacity((optionForm.OpacityTrackBar.Value + 1) / 10)
        ' gbv[Xg
        SetTopMost(optionForm.topMostCheckBox.Checked)
        ' Tuṽ^C][
        SetSubClockTimeZone(optionForm.TimeZoneComboBox.SelectedItem)
        ' CṽA[ݒ
        SetMainAlarm(optionForm.NowAlarmCheckBox.Checked, TimeValue(optionForm.txtNowAlarmTime.Text), optionForm.txtNowAlarmSoundFile.Text)
        ' TuṽA[ݒ
        SetSubAlarm(optionForm.WorldAlarmCheckBox.Checked, TimeValue(optionForm.txtWorldAlarmTime.Text), optionForm.txtWorldAlarmSoundFile.Text)

    End Sub

    ''' <summary>
    ''' ߓx̐ݒ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetOpacity(ByVal dOpacity As Double)
        clockForm.Opacity = dOpacity
    End Sub

    ''' <summary>
    ''' tH[ɎOɕ\邩ۂݒ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetTopMost(ByVal bTopMoat As Boolean)
        clockForm.TopMost = bTopMoat
    End Sub

    ''' <summary>
    ''' Tuṽ^C][w
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetSubClockTimeZone(ByVal strTimeZone As String)
        clockForm.WorldDigitalClock.CurrentTimeZone = strTimeZone
        clockForm.WorldTimeZoneNameLable.Text = strTimeZone
    End Sub

    ''' <summary>
    ''' CṽA[ݒ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetMainAlarm(ByVal mainSwitch As Boolean, ByVal mainAlaemTime As Date, ByVal strMainSoundFile As String)
        clockForm.NowDigitalClock.AlarmSetting = mainSwitch
        clockForm.NowSwitchImageButton.Switch = mainSwitch

        SetSwitchImageButton(mainSwitch, clockForm.NowSwitchImageButton)

        If mainSwitch = True Then
            clockForm.NowDigitalClock.AlarmClockTimer.Start()                   ' A[p̃^C}[Jn
            clockForm.NowDigitalClock.AlarmTime = mainAlaemTime                 ' ݒ
            clockForm.NowDigitalClock.SoundFileName = strMainSoundFile          ' 炷TEht@C
        Else
            If clockForm.NowDigitalClock.AlarmClockTimer.Enabled = True Then
                clockForm.NowDigitalClock.AlarmClockTimer.Stop()                ' A[p̃^C}[~߂
            End If
        End If

    End Sub

    ''' <summary>
    ''' TuṽA[ݒ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetSubAlarm(ByVal subSwitch As Boolean, ByVal subAlaemTime As Date, ByVal strSubSoundFile As String)
        clockForm.WorldDigitalClock.AlarmSetting = subSwitch
        clockForm.WorldSwitchImageButton.Switch = subSwitch

        SetSwitchImageButton(subSwitch, clockForm.WorldSwitchImageButton)

        If subSwitch = True Then
            clockForm.WorldDigitalClock.AlarmClockTimer.Start()                 ' A[p̃^C}[Jn
            clockForm.WorldDigitalClock.AlarmTime = subAlaemTime                ' ݒ
            clockForm.WorldDigitalClock.SoundFileName = strSubSoundFile         ' 炷TEht@C
        Else
            If clockForm.WorldDigitalClock.AlarmClockTimer.Enabled = True Then
                clockForm.WorldDigitalClock.AlarmClockTimer.Stop()              ' A[p̃^C}[~߂
            End If
        End If
    End Sub

    ''' <summary>
    ''' ON/OFF 摜`悷郁\bh
    ''' </summary>
    ''' <param name="switchImage">True=On,False=Off</param>
    ''' <param name="imageCtl">ON/OFF؂ւ SwitchImageButtonCtl</param>
    ''' <remarks></remarks>
    Private Sub SetSwitchImageButton(ByVal switchImage As Boolean, ByVal imageCtl As Control)

        If switchImage = True Then
            ' On 摜`
            imageCtl.BackgroundImage = Global.DigitalClock.My.Resources.Resources.switchon
        Else
            ' Off 摜`
            imageCtl.BackgroundImage = Global.DigitalClock.My.Resources.Resources.switchoff
        End If
    End Sub

End Class
